searchNodes=[{"doc":"","ref":"Jason.Structs.html","title":"Jason.Structs","type":"module"},{"doc":"See Jason.Structs.Decoder.decode/2 .","ref":"Jason.Structs.html#decode/2","title":"Jason.Structs.decode/2","type":"function"},{"doc":"","ref":"Jason.Structs.html#decode!/2","title":"Jason.Structs.decode!/2","type":"function"},{"doc":"See Jason.encode/2 .","ref":"Jason.Structs.html#encode/2","title":"Jason.Structs.encode/2","type":"function"},{"doc":"See Jason.encode!/2 .","ref":"Jason.Structs.html#encode!/2","title":"Jason.Structs.encode!/2","type":"function"},{"doc":"","ref":"Jason.Structs.html#t:encode_opt/0","title":"Jason.Structs.encode_opt/0","type":"type"},{"doc":"","ref":"Jason.Structs.Decoder.html","title":"Jason.Structs.Decoder","type":"module"},{"doc":"","ref":"Jason.Structs.Decoder.html#decode/2","title":"Jason.Structs.Decoder.decode/2","type":"function"},{"doc":"Implementation that is applied to all the Jason.Structs structs. Basically it encodes the structs, defined with the DSL provided by Jason.Structs to JSON. By default all keys are transofrmed from snake-styled expressions to cammel-styled expressions.","ref":"Jason.Structs.Encoder.html","title":"Jason.Structs.Encoder","type":"module"},{"doc":"Implements the Jason.Encoder.encode function for Jason.Structs structs.","ref":"Jason.Structs.Encoder.html#encode/2","title":"Jason.Structs.Encoder.encode/2","type":"function"},{"doc":"","ref":"Jason.Structs.Encoder.html#t:opts/0","title":"Jason.Structs.Encoder.opts/0","type":"opaque"},{"doc":"","ref":"Jason.Structs.Struct.html","title":"Jason.Structs.Struct","type":"module"},{"doc":"","ref":"Jason.Structs.Struct.html#jason_struct/1","title":"Jason.Structs.Struct.jason_struct/1","type":"macro"},{"doc":"","ref":"Jason.Structs.TypedStructPlugin.html","title":"Jason.Structs.TypedStructPlugin","type":"module"},{"doc":"JasonStructs A Jason plugin library that adds the ability to encode and decode structs to and from JSON. Uses the brilliant library Typed Struct to define a DSL for defining structs convertable to JSON in Elixir. It adds to Jason the ability to convert these types of structs.","ref":"readme.html","title":"JasonStructs","type":"extras"},{"doc":"It is available in Hex , so the package can be installed by adding jason_structs to your list of dependencies in mix.exs : def deps do [ { :jason_structs , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"JasonStructs - Installation","type":"extras"},{"doc":"We can define structs like this (see the tests): defmodule Country do use Jason.Structs.Struct jason_struct do field ( :code , String . t ( ) , enforce : true ) field ( :name , String . t ( ) , enforce : true ) end end defmodule Address do use Jason.Structs.Struct jason_struct do field ( :city , String . t ( ) , enforce : true ) field ( :street_address_line_one , String . t ( ) , enforce : true ) field ( :street_address_line_two , String . t ( ) , enforce : false , excludable : true ) field ( :post_code , String . t ( ) , enforce : false ) field ( :country , Country . t ( ) , enforce : true ) end end defmodule Interest do use Jason.Structs.Struct jason_struct do field ( :name , String . t ( ) , enforce : true ) field ( :description , String . t ( ) , enforce : true ) end end defmodule User do use Jason.Structs.Struct jason_struct do field ( :name , String . t ( ) , enforce : true ) field ( :age , integer ( ) , enforce : true ) field ( :sex , :male | :female , enforce : true , default : :female ) field ( :address , Address . t ( ) , enforce : true ) field ( :interests , list ( ) , excludable : true , default : [ ] ) field ( :children , [ User . t ( ) ] , excludable : true ) field ( :likes_json_structs , boolean ( ) , default : true ) end end And if we have instances of these structs like these: ivancho = % User { name : &quot;Ivan Petrov&quot; , age : 10 , sex : :male , address : % Address { city : &quot;Yambol&quot; , street_address_line_one : &quot;jk. Graph Ignatiev&quot; , street_address_line_two : &quot;bl. 72&quot; , post_code : &quot;8600&quot; , country : % Country { code : :bg , name : &quot;Bulgaria&quot; } } , interests : [ % Interest { name : &quot;Call Of Duty&quot; , description : &quot;A FPS!&quot; } , % Interest { name : &quot;Minecraft&quot; , description : &quot;Blocks and stuff!&quot; } ] , likes_json_structs : false } pesho = % User { name : &quot;Petur Petrov&quot; , age : 35 , sex : :male , address : % Address { city : &quot;Yambol&quot; , street_address_line_one : &quot;jk. Graph Ignatiev&quot; , street_address_line_two : &quot;bl. 72&quot; , post_code : &quot;8600&quot; , country : % Country { code : :bg , name : &quot;Bulgaria&quot; } } , interests : [ % Interest { name : &quot;football&quot; , description : &quot;Some people running after a ball and kicking it.&quot; } , % Interest { name : &quot;rakia&quot; , description : &quot;Alcoholic bevarage, very loved on the Balkans.&quot; } , % Interest { name : &quot;salata&quot; , description : &quot;Obicham shopskata salata, mastika ledena da pia.&quot; } ] , children : [ ivancho ] , likes_json_structs : false } We can just do {ok, json} = Jason.encode(pesho) to get: { &quot;address&quot;: { &quot;city&quot;: &quot;Yambol&quot;, &quot;country&quot;: { &quot;code&quot;: &quot;bg&quot;, &quot;name&quot;: &quot;Bulgaria&quot; }, &quot;postCode&quot;: &quot;8600&quot;, &quot;streetAddressLineOne&quot;: &quot;jk. Graph Ignatiev&quot;, &quot;streetAddressLineTwo&quot;: &quot;bl. 72&quot; }, &quot;age&quot;: 35, &quot;children&quot;: [ { &quot;address&quot;: { &quot;city&quot;: &quot;Yambol&quot;, &quot;country&quot;: { &quot;code&quot;: &quot;bg&quot;, &quot;name&quot;: &quot;Bulgaria&quot; }, &quot;postCode&quot;: &quot;8600&quot;, &quot;streetAddressLineOne&quot;: &quot;jk. Graph Ignatiev&quot;, &quot;streetAddressLineTwo&quot;: &quot;bl. 72&quot; }, &quot;age&quot;: 10, &quot;interests&quot;: [ { &quot;description&quot;: &quot;A FPS!&quot;, &quot;name&quot;: &quot;Call Of Duty&quot; }, { &quot;description&quot;: &quot;Blocks and stuff!&quot;, &quot;name&quot;: &quot;Minecraft&quot; } ], &quot;likesJsonStructs&quot;: false, &quot;name&quot;: &quot;Ivan Petrov&quot;, &quot;sex&quot;: &quot;male&quot; } ], &quot;interests&quot;: [ { &quot;description&quot;: &quot;Some people running after a ball and kicking it.&quot;, &quot;name&quot;: &quot;football&quot; }, { &quot;description&quot;: &quot;Alcoholic bevarage, very loved on the Balkans.&quot;, &quot;name&quot;: &quot;rakia&quot; }, { &quot;description&quot;: &quot;Obicham shopskata salata, mastika ledena da pia.&quot;, &quot;name&quot;: &quot;salata&quot; } ], &quot;likesJsonStructs&quot;: false, &quot;name&quot;: &quot;Petur Petrov&quot;, &quot;sex&quot;: &quot;male&quot; } And don't forget : YAMBOL IS THE CITY!","ref":"readme.html#examples","title":"JasonStructs - Examples","type":"extras"}]